> For the complete documentation index, see [llms.txt](https://docs.digitalturbine.com/llms.txt). Markdown versions of documentation pages are available by appending `.md` to page URLs; this page is available as [Markdown](https://docs.digitalturbine.com/dt-ads-demand/features-for-demand-partners/a-b-testing.md).

# A/B Testing

Digital Turbine provides an A/B Testing mechanism for Demand partners to track and measure the impact of every new SDK version and ensure we drive better performance for our buyers on every release. Better performance means higher CTR, conversion rates, and ROAS for our bidders.

## Requirements <a href="#h_01jq78j282r1rwbdf63fh4j54x" id="h_01jq78j282r1rwbdf63fh4j54x"></a>

You must have an OpenRTB integration with DT. A/B Testing does not work with server-to-server and programmatic mediation integrations.

## Specification <a href="#h_01jq6xgp1sbhg4sq96372kkykh" id="h_01jq6xgp1sbhg4sq96372kkykh"></a>

Implement A/B Testing using a custom extension in your bid request. This custom extension tells the DSP that this request is part of an A/B test and specifies which tests and groups correspond to the session.

To implement A/B Testing, use the following custom extension in your bid request:

{% code title="" %}

```
imp.ext.abgroup: "TestName1,A;TestName2,B"
```

{% endcode %}

DT supports running more than one A/B test at a time. Separate each test with a semicolon (;). If no test is relevant to the session, DT omits this custom extension.

## Reporting <a href="#h_01jq6xgp1sxgwja3cehsh2pgw8" id="h_01jq6xgp1sxgwja3cehsh2pgw8"></a>

Use KPI reports to understand the impact of new DTX SDK features on performance. DT encourages Demand partners to ingest the A/B test string value, so that you can report on performance KPIs that DT does not otherwise have access to, like conversion rate and ROAS.

## Sample Bid Request <a href="#h_01jq6xgp1snyshwqxn1g1b60c6" id="h_01jq6xgp1snyshwqxn1g1b60c6"></a>

The following sample bid request contains specifications for A/B testing.

{% code title="JSON" overflow="wrap" %}

```json
{
  "id": "780000xxxxxx9202912",
  "imp": [
    {
      "id": "1",
      "secure": 0,
      "tagid": "679721",
      "banner": {
        "id": "1",
        "w": 320,
        "h": 50,
        "wmin": 300,
        "hmin": 50,
        "pos": 4,
        "battr": [3, 6, 7, 9, 10, 14, 17],
        "topframe": 1,
        "btype": [4],
        "api": [5],
        "ext": {}
      },
      "displaymanager": "Fyber",
      "displaymanagerver": "7.4.1",
      "clickbrowser": 0,
      "instl": 0,
      "bidfloor": 5,
      "bidfloorcur": "USD",
      "ext": {
        "brsrclk": 1,
        "ctamethod": [1, 2],
        "ctatext": 1,
        "abgroup": "CTAMethod,A;VideoPlayer,B"
      }
    }
  ],
  "app": {
    "id": "67xx21",
    "name": "App_Name",
    "cat": ["IAB9-30"],
    "ver": "1.6.2",
    "bundle": "com.bundle",
    "privacypolicy": 1,
    "paid": 0,
    "publisher": {
      "id": "555555",
      "name": "App_Name",
      "ext": {}
    },
    "storeurl": "https://play.google.com/store/apps/details?id=com.bundle",
    "ext": {}
  },
  "device": {
    "dnt": 0,
    "ua": "Mozilla/5.0 (Linux; Android 9; SM-A205U1 Build/PPR1.180610.011; wv) AppleWebKit/537.36 (KHTML, like Gecko) Version/4.0 Chrome/80.0.3987.149 Mobile Safari/537.36",
    "ip": "99.203.90.47",
    "lmt": 0,
    "geo": {
      "lat": 29.772,
      "lon": -95.3644,
      "country": "USA",
      "ipservice": 3,
      "region": "TX",
      "metro": "618",
      "city": "Houston",
      "zip": "77002",
      "type": 2,
      "ext": {}
    },
    "carrier": "120",
    "language": "en",
    "make": "Samsung",
    "model": "SM-A205U1",
    "os": "Android",
    "osv": "9.0",
    "hwv": "Galaxy A20",
    "w": 411,
    "h": 813,
    "js": 1,
    "connectiontype": 6,
    "devicetype": 4,
    "ifa": "999999999999999",
    "ext": {
      "inputLanguage": ["en"]
    }
  },
  "user": {
    "gender": "",
    "ext": {
      "consent": ""
    }
  },
  "source": {
    "fd": 0,
    "tid": "7800004201389202912",
    "ext": {
      "schain": {
        "ver": "1.0",
        "complete": 1,
        "nodes": [
          {
            "asi": "fyber.com",
            "sid": "555555",
            "hp": 1,
            "rid": "78000xxxxx389202912"
          }
        ]
      }
    }
  },
  "regs": {
    "coppa": 0,
    "ext": {
      "gdpr": 0,
      "us_privacy": ""
    }
  },
  "at": 2,
  "cur": ["USD"],
  "tmax": 350,
  "bcat": ["IAB7-39","IAB14-1","IAB14-3","IAB25-1","IAB25-6","IAB8-5","IAB8-18","IAB12-2","IAB12-3","IAB11-4","IAB12-1","IAB7-28","IAB7-42","IAB17-18","IAB25-1","IAB25-2","IAB25-3","IAB25-4","IAB25-5","IAB26","IAB26-1","IAB26-2","IAB26-3","IAB26-4","IAB9-9"],
  "badv": ["advertiser.com"],
  "ext": {}
}
```

{% endcode %}

<br>


---

# Agent Instructions
This documentation is published with GitBook. GitBook is the documentation platform designed so that both humans and AI agents can read, navigate, and reason over technical content effectively. Learn more at gitbook.com.

## Querying This Documentation
If you need additional information that is not directly available in this page, you can query the documentation dynamically by asking a question.

Perform an HTTP GET request on the current page URL with the `ask` query parameter, and the optional `goal` query parameter:

```
GET https://docs.digitalturbine.com/dt-ads-demand/features-for-demand-partners/a-b-testing.md?ask=<question>&goal=<endgoal>
```

`ask` is the immediate question: it should be specific, self-contained, and written in natural language.
`goal` is optional and describes the broader end goal you are ultimately trying to accomplish on behalf of the user. GitBook uses it to tailor the answer towards what is most useful for that goal.

The response will contain a direct answer to the question and relevant excerpts and sources from the documentation.

Use this mechanism when the answer is not explicitly present in the current page, you need clarification or additional context, or you want to retrieve related documentation sections.
